//
//  920MHz LoRa/FSK RF module ES920LR3 
//
//  MaiaR create
//


#include "LoRa.h"

int resetPin = 11; // PC3
int bootPin  = 10; // PC2

void LoRaReset(){
  pinMode(bootPin, OUTPUT);  // BOOT "L"
  digitalWrite(bootPin, LOW);
  pinMode(resetPin, OUTPUT); // NRST "L"
  digitalWrite(resetPin, LOW);
  delay(10);
  pinMode(resetPin, INPUT);  // NRST open
}


void LoRaConfigMode(){
  String rx;
  Serial.begin(115200);
  Serial1.begin(115200);
  Serial1.setTimeout(50);
  while(1){
    LoRaReset();
    rx = Serial1.readString();
    Serial.println(rx);
    if (rx.indexOf("Select Mode") >= 0) break;
    LoRaCommand("config");
    delay(100); 
  }
}


int LoRaCommand(String s){
  String rx;
  Serial1.print(s);
  Serial1.print("\r\n");
  Serial1.flush();
  Serial.println(s);
  delay(10);
  rx = Serial1.readString();
  Serial.print(rx);
  return (rx.indexOf("OK"));
}


int LoRaInit(){
  LoRaConfigMode();
  if (LoRaCommand("2"     ) < 0) return(-1); // processor mode
  if (LoRaCommand("x"     ) < 0) return(-1); // default
  if (LoRaCommand("c 12"  ) < 0) return(-1); // spread factor
  if (LoRaCommand("d 3"   ) < 0) return(-1); // channel
  if (LoRaCommand("e 2345") < 0) return(-1); // PAN ID
  if (LoRaCommand("f 1"   ) < 0) return(-1); // own ID
  if (LoRaCommand("g ffff") < 0) return(-1); // broadcast
  if (LoRaCommand("p 1"   ) < 0) return(-1); // RSSI on
  if (LoRaCommand("z"     ) < 0) return(-1); // start
  return(0);
}
